## fcitx 4.2.1

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)

project(fcitx)

set(version 4.2.1)

set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})

option(ENABLE_CAIRO "Enable Cairo" ON)
option(ENABLE_DBUS "Enable DBus Support" ON)
option(ENABLE_PANGO "Enable Pango Support" ON)
option(ENABLE_DEBUG "Enable Debug" OFF)
option(ENABLE_TABLE "Enable Table IM" ON)
option(ENABLE_GTK2_IM_MODULE "Enable GTK2 IM Module" ON)
option(ENABLE_GTK3_IM_MODULE "Enable GTK3 IM Module" OFF)
option(ENABLE_QT_IM_MODULE "Enable Qt IM Module" OFF)
option(ENABLE_OPENCC "Enable OpenCC for Chinese Transform" ON)
option(ENABLE_STATIC "Build Static Library" OFF)
option(ENABLE_TEST "Test build" OFF)
option(ENABLE_SNOOPER "Enable Key Snooper for gtk app" On)

if (NOT NO_SNOOPER_APPS)
set(NO_SNOOPER_APPS ".*chrome.*,.*chromium.*,firefox.*,Do.*" CACHE STRING "Disable Key Snooper for following app")
endif (NOT NO_SNOOPER_APPS)

# uninstall target
configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY)

add_custom_target(uninstall
    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)

include(CheckIncludeFiles)
include(CheckFunctionExists)
include(FindPkgConfig)
include(UseDoxygen OPTIONAL)
include(FcitxMacro)

check_include_files(unistd.h HAVE_UNISTD_H)
check_include_files(malloc.h HAVE_MALLOC_H)
check_include_files(stdbool.h HAVE_STDBOOL_H)
check_function_exists(asprintf HAVE_ASPRINTF)

FIND_PACKAGE(Gettext REQUIRED)
FIND_PACKAGE(Libintl REQUIRED)
FIND_PACKAGE(Libiconv REQUIRED)
FIND_PACKAGE(Pthread REQUIRED)
FIND_PACKAGE(Libexecinfo REQUIRED)
FIND_PACKAGE(Libkvm)
FIND_PACKAGE(DL REQUIRED)
FIND_PROGRAM(WGET wget)
FIND_PROGRAM(TAR tar)

FIND_PACKAGE(X11 REQUIRED)

if (ENABLE_TEST)
    ENABLE_TESTING()
endif (ENABLE_TEST)

set(_ENABLE_CAIRO 0)
set(_ENABLE_PANGO 0)
if (ENABLE_CAIRO)
    PKG_CHECK_MODULES(CAIRO_XLIB REQUIRED "cairo-xlib >= 1.0" )
    if (CAIRO_XLIB_FOUND)
        set(_ENABLE_CAIRO 1)
    endif (CAIRO_XLIB_FOUND)
endif (ENABLE_CAIRO)

set(_ENABLE_PANGO 0)
if (_ENABLE_CAIRO)
    if (ENABLE_PANGO)
        PKG_CHECK_MODULES(PANGOCAIRO "pangocairo >= 1.0" )
        if (PANGOCAIRO_FOUND)
            set(_ENABLE_PANGO 1)
        endif (PANGOCAIRO_FOUND)
    endif (ENABLE_PANGO)
    if (NOT _ENABLE_PANGO)
        PKG_CHECK_MODULES(FONTCONFIG REQUIRED "fontconfig")
    endif (NOT _ENABLE_PANGO)
endif(_ENABLE_CAIRO)

set(_ENABLE_DBUS 0)
if (ENABLE_DBUS)
    PKG_CHECK_MODULES(DBUS "dbus-1 >= 1.1.0" )
    if (DBUS_FOUND)
        set(_ENABLE_DBUS 1)
    endif (DBUS_FOUND)
endif (ENABLE_DBUS)

set(_ENABLE_OPENCC 0)
if (ENABLE_OPENCC)
    PKG_CHECK_MODULES(OPENCC "opencc >= 0.1.1" )
    if (OPENCC_FOUND)
        set(_ENABLE_OPENCC 1)
    endif (OPENCC_FOUND)
endif (ENABLE_OPENCC)

set(HAVE_XINERAMA 0)
if (X11_Xinerama_FOUND)
    set(HAVE_XINERAMA 1)
endif (X11_Xinerama_FOUND)

if(ENABLE_DEBUG)
    set(_DEBUG)
endif(ENABLE_DEBUG)

set(package     fcitx)
set(prefix      ${CMAKE_INSTALL_PREFIX})
set(exec_prefix ${CMAKE_INSTALL_PREFIX})
set(bindir ${exec_prefix}/bin)

if(NOT DEFINED LIB_INSTALL_DIR)
    set(LIB_INSTALL_DIR ${exec_prefix}/lib)
endif()

set(libdir ${LIB_INSTALL_DIR})
set(addondir ${libdir}/${package} )
set(pkgdatadir ${prefix}/share/${package})
set(configdescdir ${pkgdatadir}/configdesc)
set(addonconfigdir ${pkgdatadir}/addon)
set(imconfigdir ${pkgdatadir}/inputmethod)
set(localedir ${CMAKE_INSTALL_PREFIX}/share/locale)
set(includedir  ${CMAKE_INSTALL_PREFIX}/include)

list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${LIB_INSTALL_DIR}" _isSystemPlatformLibDir)
list(FIND CMAKE_CXX_IMPLICIT_LINK_DIRECTORIES "${LIB_INSTALL_DIR}" _isSystemCxxLibDir)
if("${_isSystemPlatformLibDir}" STREQUAL "-1" AND "${_isSystemCxxLibDir}" STREQUAL "-1")
    set(CMAKE_SKIP_BUILD_RPATH  FALSE)
    set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
    set(CMAKE_INSTALL_RPATH "${LIB_INSTALL_DIR}")
    set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
endif("${_isSystemPlatformLibDir}" STREQUAL "-1" AND "${_isSystemCxxLibDir}" STREQUAL "-1")

# For FcitxMacro
set(FCITX4_ADDON_INSTALL_DIR ${addondir})
set(FCITX4_CONFIGDESC_INSTALL_DIR ${configdescdir})
set(FCITX4_ADDON_CONFIG_INSTALL_DIR ${addonconfigdir})
set(FCITX4_INPUTMETHOD_CONFIG_INSTALL_DIR ${imconfigdir})
set(FCITX4_PACKAGE_NAME ${package})

set(CMAKE_C_FLAGS "-Wall -Wextra -Wno-sign-compare -Wno-unused-parameter -fvisibility=hidden ${CMAKE_C_FLAGS}")
set(CMAKE_CXX_FLAGS "-Wall -Wextra -Wno-sign-compare -Wno-unused-parameter -fvisibility=hidden ${CMAKE_CXX_FLAGS}")
set(CMAKE_SHARED_LINKER_FLAGS "-Wl,--as-needed ${CMAKE_SHARED_LINKER_FLAGS}")
set(CMAKE_MODULE_LINKER_FLAGS "-Wl,--as-needed ${CMAKE_MODULE_LINKER_FLAGS}")
add_definitions("-D_GNU_SOURCE -DFCITX_HAVE_CONFIG_H")

configure_file(${PROJECT_SOURCE_DIR}/config.h.in ${PROJECT_BINARY_DIR}/config.h)
configure_file("${PROJECT_SOURCE_DIR}/cmake/FcitxConfigVersion.cmake.in"
               "${PROJECT_BINARY_DIR}/cmake/FcitxConfigVersion.cmake"
                IMMEDIATE @ONLY
)

include_directories(${PROJECT_BINARY_DIR})

add_subdirectory(src)
add_subdirectory(doc)
add_subdirectory(skin)
add_subdirectory(tools)
add_subdirectory(data)
add_subdirectory(po)
add_subdirectory(cmake)

if (ENABLE_TEST)
    add_subdirectory(test)
endif (ENABLE_TEST)

=== data/CMakeLists.txt ===
if (ENABLE_TABLE)
    add_subdirectory(table)
endif (ENABLE_TABLE)

add_subdirectory(script)
add_subdirectory(icon)

set(FCITX_DESC_FILES
    addon.desc
    config.desc
    profile.desc
    inputmethod.desc
)

set(FCITX_DATA_FILES
    AutoEng.dat
    gbks2t.tab
    punc.mb.zh_CN
    punc.mb.zh_TW
    vk.conf
)

set(FCITX_PY_FILES
    pySym.mb
    sp.dat
)

set(FCITX_DSEKTOP_FILES
    fcitx.desktop
    fcitx-configtool.desktop
)

set(PY_ORGDATA pyPhrase.org)
set(PY_DATA ${CMAKE_CURRENT_BINARY_DIR}/pybase.mb ${CMAKE_CURRENT_BINARY_DIR}/pyphrase.mb)
set(PY_TAR ${CMAKE_CURRENT_SOURCE_DIR}/pinyin.tar.gz)
set(PY_URL http://fcitx.googlecode.com/files/pinyin.tar.gz)


intltool_merge_translation(${CMAKE_CURRENT_SOURCE_DIR}/fcitx-configtool.desktop.in ${CMAKE_CURRENT_BINARY_DIR}/fcitx-configtool.desktop )
intltool_merge_translation(${CMAKE_CURRENT_SOURCE_DIR}/fcitx.desktop.in ${CMAKE_CURRENT_BINARY_DIR}/fcitx.desktop )

add_custom_target(pinyin_data ALL DEPENDS ${PY_DATA})

add_custom_command(OUTPUT ${PY_ORGDATA}
                   COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/download.sh "${WGET}" "${PY_URL}" "${PY_TAR}"
                   COMMAND ${TAR} xzmvf ${PY_TAR})
add_custom_command(OUTPUT ${PY_DATA}
                   DEPENDS ${PY_ORGDATA}
                   COMMAND createPYMB ${CMAKE_CURRENT_SOURCE_DIR}/gbkpy.org ${CMAKE_CURRENT_BINARY_DIR}/${PY_ORGDATA})

add_custom_target(desktopfile ALL DEPENDS ${FCITX_DSEKTOP_FILES})
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/fcitx.desktop DESTINATION share/applications/)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/fcitx-configtool.desktop DESTINATION share/applications/)

install(FILES ${FCITX_DATA_FILES} DESTINATION ${pkgdatadir}/data)
fcitx_add_configdesc_file(${FCITX_DESC_FILES})
install(FILES ${FCITX_PY_FILES} ${CMAKE_CURRENT_BINARY_DIR}/pybase.mb ${CMAKE_CURRENT_BINARY_DIR}/pyphrase.mb DESTINATION ${pkgdatadir}/pinyin)

set_directory_properties(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES "${CMAKE_CURRENT_BINARY_DIR}/pyERROR,${CMAKE_CURRENT_BINARY_DIR}/pyPhrase.ok")

=== test/CMakeLists.txt ===
add_executable(testconfig testconfig.c)
target_link_libraries(testconfig fcitx-config)

add_executable(testmessage testmessage.c)
target_link_libraries(testmessage fcitx-core)

add_executable(teststring teststring.c)
target_link_libraries(teststring fcitx-utils)

include_directories(${PROJECT_SOURCE_DIR}/src)
include_directories(${PROJECT_SOURCE_DIR}/src/lib)

add_test(NAME testconfig
         COMMAND testconfig ${CMAKE_CURRENT_SOURCE_DIR}/test.desc ${CMAKE_CURRENT_SOURCE_DIR}/test.conf ${CMAKE_CURRENT_BINARY_DIR}/test.conf)

add_test(NAME testmessage
         COMMAND testmessage)
         
add_test(NAME teststring
         COMMAND teststring)

=== skin/classic/CMakeLists.txt ===
set(FCITX_CLASSIC_SKIN_FILES
chttrans_active.png chttrans_inactive.png
fullwidth_active.png fullwidth_inactive.png
punc_active.png punc_inactive.png
 active.png  bingchan.png erbi.png  fcitx_skin.conf
 input.png  remind_active.png remind_inactive.png  quwei.png  vk_active.png vk_inactive.png wubi.png wbpy.png ziranma.png
 bar.png cangjie.png  cn.png en.png inactive.png logo.png
 dianbaoma.png shuangpin.png wanfeng.png pinyin.png prev.png next.png menu.png
 kbd.png
)

install(FILES ${FCITX_CLASSIC_SKIN_FILES} DESTINATION ${pkgdatadir}/skin/classic)

=== skin/dark/CMakeLists.txt ===
set(FCITX_DARK_SKIN_FILES
active.png  bingchan.png erbi.png  fcitx_skin.conf 
input.png quwei.png wubi.png wbpy.png ziranma.png
bar.png cangjie.png  cn.png en.png  inactive.png logo.png
dianbaoma.png shuangpin.png wanfeng.png pinyin.png prev.png next.png menu.png keyboard.png
remind_active.png remind_inactive.png vk_active.png vk_inactive.png
punc_active.png punc_inactive.png fullwidth_active.png fullwidth_inactive.png
chttrans_active.png chttrans_inactive.png
kbd.png
)

install(FILES ${FCITX_DARK_SKIN_FILES} DESTINATION ${pkgdatadir}/skin/dark)

=== skin/default/CMakeLists.txt ===
set(FCITX_DEFAULT_SKIN_FILES
chttrans_active.png chttrans_inactive.png
fullwidth_active.png fullwidth_inactive.png
punc_active.png punc_inactive.png
active.png  bingchan.png erbi.png  fcitx_skin.conf 
input.png  remind_active.png remind_inactive.png  quwei.png vk_active.png vk_inactive.png
wubi.png wbpy.png ziranma.png
bar.png cangjie.png  cn.png en.png  inactive.png logo.png
dianbaoma.png shuangpin.png wanfeng.png pinyin.png prev.png next.png keyboard.png menu.png
kbd.png
)

install(FILES ${FCITX_DEFAULT_SKIN_FILES} DESTINATION ${pkgdatadir}/skin/default)

=== src/im/CMakeLists.txt ===
add_subdirectory(pinyin)

if (ENABLE_TABLE)
    add_subdirectory(table)
endif (ENABLE_TABLE)

add_subdirectory(qw)

=== src/module/CMakeLists.txt ===
add_subdirectory(x11)
add_subdirectory(chttrans)
add_subdirectory(punc)
add_subdirectory(quickphrase)
add_subdirectory(autoeng)
add_subdirectory(fullwidthchar)
add_subdirectory(remote)
if (_ENABLE_CAIRO)
    add_subdirectory(vk)
endif (_ENABLE_CAIRO)

if (_ENABLE_DBUS)
    add_subdirectory(dbus)
endif (_ENABLE_DBUS)

=== src/frontend/gtk2/CMakeLists.txt ===
if(ENABLE_GTK2_IM_MODULE)

PKG_CHECK_MODULES(GTK2 REQUIRED "gtk+-2.0" )

_pkgconfig_invoke("gtk+-2.0" GTK2 BINARY_VERSION "" "--variable=gtk_binary_version")
_pkgconfig_invoke("gtk+-2.0" GTK2 LIBDIR "" "--variable=libdir")
set(GTK2_IM_MODULEDIR
 "${GTK2_LIBDIR}/gtk-2.0/${GTK2_BINARY_VERSION}/immodules"
)

include_directories(${GTK2_INCLUDE_DIRS})
include_directories(${DBUS_GLIB_INCLUDE_DIRS})
include_directories(${CMAKE_CURRENT_BINARY_DIR})
link_directories(${GTK2_LIBRARY_DIRS} ${DBUS_GLIB_LIBRARY_DIRS})

add_custom_command(OUTPUT marshall.c
                   COMMAND ${GLIB_GENMARSHAL} --body --prefix=fcitx_marshall ${PROJECT_SOURCE_DIR}/src/frontend/gtk-common/marshall.list > marshall.c
                   DEPENDS ${PROJECT_SOURCE_DIR}/src/frontend/gtk-common/marshall.list 
)
add_custom_command(OUTPUT marshall.h
                   COMMAND ${GLIB_GENMARSHAL} --header --prefix=fcitx_marshall ${PROJECT_SOURCE_DIR}/src/frontend/gtk-common/marshall.list > marshall.h
                   DEPENDS ${PROJECT_SOURCE_DIR}/src/frontend/gtk-common/marshall.list 
)

set(FCITX_GTK2_IM_MODULE_SOURCES
    fcitxim.c
    fcitximcontext.c
    client.c
    ${CMAKE_CURRENT_BINARY_DIR}/marshall.c
    ${CMAKE_CURRENT_BINARY_DIR}/marshall.h
)

add_library(im-fcitx MODULE ${FCITX_GTK2_IM_MODULE_SOURCES})
set_target_properties( im-fcitx PROPERTIES PREFIX "" COMPILE_FLAGS "-fvisibility=hidden" LINK_FLAGS "-Wl,--no-undefined")
target_link_libraries( im-fcitx ${GTK2_LIBRARIES} ${DBUS_GLIB_LIBRARIES} fcitx-utils)

install(TARGETS im-fcitx DESTINATION ${GTK2_IM_MODULEDIR})

endif(ENABLE_GTK2_IM_MODULE)

=== src/frontend/gtk3/CMakeLists.txt ===
if(ENABLE_GTK3_IM_MODULE)

PKG_CHECK_MODULES(GTK3 REQUIRED "gtk+-3.0" )

_pkgconfig_invoke("gtk+-3.0" GTK3 BINARY_VERSION "" "--variable=gtk_binary_version")
_pkgconfig_invoke("gtk+-3.0" GTK3 LIBDIR "" "--variable=libdir")
set(GTK3_IM_MODULEDIR
 "${GTK3_LIBDIR}/gtk-3.0/${GTK3_BINARY_VERSION}/immodules"
)

include_directories(${GTK3_INCLUDE_DIRS})
include_directories(${DBUS_GLIB_INCLUDE_DIRS})
include_directories(${CMAKE_CURRENT_BINARY_DIR})
link_directories(${GTK3_LIBRARY_DIRS} ${DBUS_GLIB_LIBRARY_DIRS})

add_custom_command(OUTPUT marshall.c
                   COMMAND ${GLIB_GENMARSHAL} --body --prefix=fcitx_marshall ${PROJECT_SOURCE_DIR}/src/frontend/gtk-common/marshall.list > marshall.c
                   DEPENDS ${PROJECT_SOURCE_DIR}/src/frontend/gtk-common/marshall.list 
)
add_custom_command(OUTPUT marshall.h
                   COMMAND ${GLIB_GENMARSHAL} --header --prefix=fcitx_marshall ${PROJECT_SOURCE_DIR}/src/frontend/gtk-common/marshall.list > marshall.h
                   DEPENDS ${PROJECT_SOURCE_DIR}/src/frontend/gtk-common/marshall.list 
)

set(FCITX_GTK3_IM_MODULE_SOURCES
    ../gtk2/fcitxim.c
    ../gtk2/fcitximcontext.c
    ../gtk2/client.c
    ${CMAKE_CURRENT_BINARY_DIR}/marshall.c
    ${CMAKE_CURRENT_BINARY_DIR}/marshall.h
)

add_library(im-fcitx-gtk3 MODULE ${FCITX_GTK3_IM_MODULE_SOURCES})
set_target_properties( im-fcitx-gtk3 PROPERTIES PREFIX "" COMPILE_FLAGS "-fvisibility=hidden" OUTPUT_NAME "im-fcitx" LINK_FLAGS "-Wl,--no-undefined")

target_link_libraries( im-fcitx-gtk3 ${GTK3_LIBRARIES} ${DBUS_GLIB_LIBRARIES} fcitx-utils)

install(TARGETS im-fcitx-gtk3 DESTINATION ${GTK3_IM_MODULEDIR})

endif(ENABLE_GTK3_IM_MODULE)

=== src/frontend/qt/CMakeLists.txt ===
if (ENABLE_QT_IM_MODULE)
find_package(Qt4 4.5 COMPONENTS QtCore QtGui QtDBus REQUIRED)
find_package(ICU REQUIRED)

# use newer macro from Qt4Macro.cmake
MACRO(FCITX_QT4_ADD_DBUS_INTERFACE _sources _interface _basename)
  GET_FILENAME_COMPONENT(_infile ${_interface} ABSOLUTE)
  SET(_header ${CMAKE_CURRENT_BINARY_DIR}/${_basename}.h)
  SET(_impl   ${CMAKE_CURRENT_BINARY_DIR}/${_basename}.cpp)
  SET(_moc    ${CMAKE_CURRENT_BINARY_DIR}/${_basename}.moc)

  GET_SOURCE_FILE_PROPERTY(_nonamespace ${_interface} NO_NAMESPACE)
  IF(_nonamespace)
    SET(_params -N -m)
  ELSE(_nonamespace)
    SET(_params -m)
  ENDIF(_nonamespace)

  GET_SOURCE_FILE_PROPERTY(_classname ${_interface} CLASSNAME)
  IF(_classname)
    SET(_params ${_params} -c ${_classname})
  ENDIF(_classname)

  GET_SOURCE_FILE_PROPERTY(_include ${_interface} INCLUDE)
  IF(_include)
    SET(_params ${_params} -i ${_include})
  ENDIF(_include)

  ADD_CUSTOM_COMMAND(OUTPUT ${_impl} ${_header}
      COMMAND ${QT_DBUSXML2CPP_EXECUTABLE} ${_params} -p ${_basename} ${_infile}
      DEPENDS ${_infile} VERBATIM)

  SET_SOURCE_FILES_PROPERTIES(${_impl} PROPERTIES SKIP_AUTOMOC TRUE)

  QT4_GENERATE_MOC(${_header} ${_moc})

  SET(${_sources} ${${_sources}} ${_impl} ${_header} ${_moc})
  MACRO_ADD_FILE_DEPENDENCIES(${_impl} ${_moc})

ENDMACRO(FCITX_QT4_ADD_DBUS_INTERFACE)

include_directories(
    ${QT_INCLUDE_DIR}
    ${QT_QTCORE_INCLUDE_DIR}
    ${QT_QTGUI_INCLUDE_DIR}
    ${QT_QTDBUS_INCLUDE_DIR}
    ${X11_INCLUDE_DIRS}
    ${DBUS_INCLUDE_DIRS}
    ${ICU_INCLUDE_DIRS}
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}
)

link_directories(
    ${X11_LIBRARY_DIRS}
    ${DBUS_LIBRARY_DIRS}
)

set(
    qtim_fcitx_SRCS
    fcitx-plugin.cpp
    fcitx-input-context.cpp
    fcitx-formatted-preedit.cpp
)

set_property(
    SOURCE org.fcitx.Fcitx.InputContext.xml
    PROPERTY INCLUDE fcitx-formatted-preedit.h
)

FCITX_QT4_ADD_DBUS_INTERFACE(qtim_fcitx_SRCS
    org.fcitx.Fcitx.InputContext.xml
    org.fcitx.Fcitx.InputContext
)

FCITX_QT4_ADD_DBUS_INTERFACE(qtim_fcitx_SRCS
    org.fcitx.Fcitx.InputMethod.xml
    org.fcitx.Fcitx.InputMethod
)

FCITX_QT4_ADD_DBUS_INTERFACE(qtim_fcitx_SRCS
    org.freedesktop.DBus.xml
    org.freedesktop.DBus
)


set(
    qtim_fcitx_MOC_HDRS
    fcitx-input-context.h
)

QT4_AUTOMOC(${qtim_fcitx_SRCS})
QT4_WRAP_CPP(
    qtim_fcitx_MOC_SRCS
    ${qtim_fcitx_MOC_HDRS}
)

add_library(
    qtim-fcitx MODULE
    ${qtim_fcitx_SRCS}
    ${qtim_fcitx_MOC_SRCS}
)

set_target_properties( qtim-fcitx PROPERTIES PREFIX "" COMPILE_FLAGS "-fvisibility=hidden" LINK_FLAGS "-Wl,--no-undefined")

target_link_libraries(
    qtim-fcitx
    debug ${QT_QTCORE_LIBRARY_DEBUG}
    debug ${QT_QTDBUS_LIBRARY_DEBUG}
    debug ${QT_QTGUI_LIBRARY_DEBUG}
    optimized ${QT_QTCORE_LIBRARY_RELEASE}
    optimized ${QT_QTDBUS_LIBRARY_RELEASE}
    optimized ${QT_QTGUI_LIBRARY_RELEASE}
    ${X11_LIBRARIES}
    ${ICU_LIBRARIES}
    fcitx-config
)

install(
    TARGETS qtim-fcitx
    LIBRARY DESTINATION
    ${QT_PLUGINS_DIR}/inputmethods)

endif (ENABLE_QT_IM_MODULE)

=== src/lib/fcitx-config/CMakeLists.txt ===
set(FCITX_CONFIG_SOURCES
    fcitx-config.c
    hotkey.c
    sprintf.c
    xdg.c
)

set(FCITX_CONFIG_HEADERS
    fcitx-config.h
    hotkey.h
    xdg.h
)

add_library(fcitx-config SHARED ${FCITX_CONFIG_SOURCES})
target_link_libraries(fcitx-config fcitx-utils)
set_target_properties(fcitx-config
                      PROPERTIES VERSION 4.1
                      SOVERSION 4
                      COMPILE_FLAGS "-fvisibility=hidden"
                      LINK_FLAGS "-Wl,--no-undefined"
)

configure_file(fcitx-config.pc.in ${CMAKE_CURRENT_BINARY_DIR}/fcitx-config.pc)

install(TARGETS fcitx-config DESTINATION ${libdir})
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/fcitx-config.pc DESTINATION "${libdir}/pkgconfig")
install(FILES ${FCITX_CONFIG_HEADERS} DESTINATION "${includedir}/fcitx-config")

if (ENABLE_STATIC)

add_library(fcitx-config-static STATIC ${FCITX_CONFIG_SOURCES})
set_target_properties(fcitx-config-static PROPERTIES
    OUTPUT_NAME "fcitx-config"
    PREFIX "lib"
)

install(TARGETS fcitx-config-static
    LIBRARY DESTINATION ${libdir}
    ARCHIVE DESTINATION ${libdir}
)
endif (ENABLE_STATIC)

=== debian/changelog ===
fcitx (1:4.2.1-1) unstable; urgency=low

  * New upstream release.
  * debian/im-switch/fcitx:
    - Change to QT_IM_MODULE from QT4_IM_MODULE to work around
      im-switch bug.

 -- Aron Xu <aron@debian.org>  Sat, 17 Mar 2012 15:59:56 +0800

=== debian/control ===
Source: fcitx
Section: utils
Priority: optional
Maintainer: IME Packaging Team <pkg-ime-devel@lists.alioth.debian.org>
Uploaders: Aron Xu <aron@debian.org>, YunQiang Su <wzssyqa@gmail.com>
DM-Upload-Allowed: yes
Build-Depends: debhelper (>= 9), cmake, intltool (>= 0.35.0),
    libdbus-1-dev (>= 1.1.0), libpango1.0-dev (>= 1.0), libcairo2-dev (>= 1.0),
    libdbus-glib-1-dev, libopencc-dev (>= 0.1.1~), libicu-dev,
    libgtk2.0-dev, libqt4-dev, libgtk-3-dev, libkvm-dev [kfreebsd-any]
Standards-Version: 3.9.3
Homepage: http://code.google.com/p/fcitx/
Vcs-Git: git://git.debian.org/pkg-ime/fcitx.git
Vcs-Browser: http://git.debian.org/?p=pkg-ime/fcitx.git

Package: fcitx
Architecture: all
Depends: ${misc:Depends}, fcitx-bin, fcitx-data, fcitx-modules,
    fcitx-module-x11, fcitx-ui-classic
Recommends: fcitx-pinyin, fcitx-googlepinyin | fcitx-sunpinyin, 
    fcitx-table-wubi | fcitx-table-wbpy, fcitx-config-gtk,
    fcitx-frontend-gtk2, fcitx-frontend-gtk3, fcitx-frontend-qt4,
    im-config (>= 0.5) | im-switch
Suggests: fcitx-tools
Description: Flexible Input Method Framework
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems. 
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This metapackage pulls in a set of components recommended for most desktop
 users.

Package: fcitx-bin
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: fcitx-data, fcitx-modules
Suggests: fcitx (>= 1:4.2.0)
Replaces: fcitx (<< 1:4.2.0)
Breaks: fcitx (<< 1:4.2.0)
Description: Flexible Input Method Framework - essential binaries
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems. 
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package provides the essential executable binaries. If you are
 looking for a working input experience, please install the package 
 "fcitx" instead.

Package: fcitx-data
Architecture: all
Depends: ${misc:Depends}
Recommends: fcitx-bin
Suggests: fcitx (>= 1:4.2.0)
Replaces: fcitx (<< 1:4.2.0)
Breaks: fcitx (<< 1:4.2.0)
Multi-arch: foreign
Description: Flexible Input Method Framework - essential data files
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems. 
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package provides the essential data files. If you are looking for a
 working input experience, please install the package "fcitx" instead.

Package: fcitx-libs
Architecture: any
Section: libs
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: fcitx (>= 1:4.2.0)
Replaces: fcitx (<< 1:4.2.0)
Breaks: fcitx (<< 1:4.2.0)
Description: Flexible Input Method Framework - library files
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems. 
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package contains three libraries:
  * libfcitx-core - core functions of Fcitx
  * libfcitx-config - support library for Fcitx configurations
  * libfcitx-utils - utility support library for Fcitx

Package: fcitx-libs-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends}, fcitx-libs (= ${binary:Version})
Replaces: fcitx (<< 1:4.2.0)
Breaks: fcitx (<< 1:4.2.0)
Description: Flexible Input Method Framework - library development files
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems. 
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package provides the library development files.

Package: fcitx-dbg
Architecture: any
Section: debug
Priority: extra
Depends: ${misc:Depends}, fcitx-libs (= ${binary:Version})
Provides: fcitx-libs-dbg
Replaces: fcitx (<< 1:4.2.0), fcitx-libs-dbg
Breaks: fcitx (<< 1:4.2.0), fcitx-libs-dbg
Description: Flexible Input Method Framework - debugging symbols
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems. 
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package provides the debugging symbols of the whole Fcitx.

Package: fcitx-ui-kimpanel
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, fcitx-module-dbus
Recommends: kdebase-bin
Replaces: fcitx (<< 1:4.2.0)
Breaks: fcitx (<< 1:4.2.0)
Suggests: plasma-widgets-addons
Description: Flexible Input Method Framework - KIMPanel user interface
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems. 
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package provides the KIMPanel user interface of Fcitx, which is a
 good choice for KDE4 users. Also it implements a protocol to talk with
 D-Bus, so it might be needed by other desktop environment users like
 GNOME Shell and Unity.

Package: fcitx-ui-classic
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, fcitx-module-x11
Recommends: fcitx (>= 1:4.2.0), zenity
Replaces: fcitx (<< 1:4.2.0)
Breaks: fcitx (<< 1:4.2.0)
Description: Flexible Input Method Framework - Classic user interface
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems. 
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package provides the classic user interface, which is suitable 
 for most users. It also provides the following skins:
  * classic: Fcitx 3.x classic skin ported to new infrastructure
  * dark: the dark skin fits for dark desktop theme
  * default: the default skin

Package: fcitx-frontend-all
Architecture: all
Depends: ${misc:Depends}, fcitx-frontend-gtk2, fcitx-frontend-gtk3, 
    fcitx-frontend-qt4, fcitx-module-x11, fcitx-module-dbus
Description: Flexible Input Method Framework - frontends metapackage
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems. 
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This metapackage pulls in the following frontends:
  * XIM protocol client
  * GTK+ 2/3 IM Module
  * QT 4 IM Module
  * IPC frontend (based on D-Bus, used by various IM Modules)

Package: fcitx-frontend-gtk2
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}, fcitx-module-dbus
Recommends: fcitx-frontend-gtk3
Description: Flexible Input Method Framework - GTK+ 2 IM Module frontend
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems. 
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package provides the GTK+ 2 IM Module frontend, which is
 recommended for all desktop users.

Package: fcitx-frontend-gtk3
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}, fcitx-module-dbus
Recommends: fcitx-frontend-gtk2
Description: Flexible Input Method Framework - GTK+ 3 IM Module frontend
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems. 
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package provides the GTK+ 3 IM Module frontend, which is
 recommended for all desktop users. This is the best solution if you are
 looking for a better input experience with GTK+ 3 applications.

Package: fcitx-frontend-qt4
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, fcitx-module-dbus
Description: Flexible Input Method Framework - QT 4 IM Module frontend
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems. 
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package provides the QT 4 IM Module frontend, which is recommended
 for KDE4 desktop users.

Package: fcitx-pinyin
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, fcitx-bin,
  fcitx-data (>= 1:4.2.0), fcitx-modules
Recommends: fcitx (>= 1:4.2.0)
Replaces: fcitx (<< 1:4.2.0)
Breaks: fcitx (<< 1:4.2.0)
Description: Flexible Input Method Framework - classic Pinyin engine
